Attribute VB_Name = "modToolTip"
' This was written in Visual Basic 6.0
' by Craig Jasper, Jr., also known as Blah
' at www.patorjk.com on February 2, 2000.

' This is an example on how to make Multi-Line ToolTips.
' There is room for improvement here too. This is to
' give you the idea.

' --------------------------------------------------------

' This project needs the following Forms/Controls:

'                   frmToolTip Controls:
' Add a Form named frmToolTip.
' Set frmToolTip's BoarderStyle to 1.
' Set frmToolTip's Caption to "".
' Set the ControlBox property on frmTip to False.
' Set frmToolTip's ShowInTaskBar to False.
' Set frmToolTip's BackColor to &H80000018&

' Add a label named lblToolTip.
' Set lblToolTip's AutoSize property to True.
' Set lblToolTip's BackColor to &H80000018&
' Set lblToolTip's caption to "".

' --------------------------------------------------------

'                   Form1 Controls:
' Add a Form named Form1.
' Add two Command Buttons named Command1 and Command2.
' Add two Timers, named Timer1 and Timer2.
' Set Timer1's Enabled property to False.
' Set Timer2's Enabled property set to True.
' Both timers need an interval of 100.

' ---------------------------------------------------------

' Module Code:

Option Explicit

Public Declare Function GetCursorPos& Lib _
"user32" (lpPoint As POINTAPI)

Public Declare Function _
GetActiveWindow& Lib "user32" ()

Public Declare Function ShowWindow& Lib "user32" _
(ByVal hWnd As Long, ByVal nCmdShow As Long)

Public Declare Function WindowFromPoint _
Lib "user32" (ByVal xPoint As Long, _
ByVal yPoint As Long) As Long

Public Const SW_HIDE& = 0
Public Const SW_SHOWNOACTIVATE& = 4
Public Const SW_SHOW& = 5

Type POINTAPI
    X As Long
    Y As Long
End Type

' ToolTips strings. To add a new line just
' use vbCrLf.
Global Const TIPONE = "This is " & vbCrLf & "tip one"
Global Const TIPTWO = "This is " & vbCrLf & "tip two"
Sub ShowToolTip(ByVal strTip As Variant)
Dim lres As Long, temptagstring As String, tipstring As String
Dim tippoint As POINTAPI, toffset As Integer, loffset As Integer

    If VarType(strTip) = 8 Then
        If Len(strTip) > 0 Then
            temptagstring = strTip
            tipstring = strTip
        End If
    End If

    If tipstring = "" Then
        lres& = ShowWindow(frmToolTip.hWnd, SW_HIDE)
    End If

    If tipstring <> "" Then
        frmToolTip.lblToolTip.Caption = tipstring
        GetCursorPos tippoint
        toffset = 18: loffset = -2
        frmToolTip.Top = (tippoint.Y + toffset%) * Screen.TwipsPerPixelY
        frmToolTip.Left = (tippoint.X + loffset%) * Screen.TwipsPerPixelX
        frmToolTip.Width = frmToolTip.lblToolTip.Width + (4 * Screen.TwipsPerPixelX)
        frmToolTip.Height = frmToolTip.lblToolTip.Height + (2 * Screen.TwipsPerPixelY)
        frmToolTip.ZOrder
        
        lres = ShowWindow(frmToolTip.hWnd, SW_SHOWNOACTIVATE)
    Else
        lres = ShowWindow(frmToolTip.hWnd, SW_HIDE)
    End If
End Sub

' --------------------------------------------------------

' frmToolTip's Code:

' Option Explicit

' Private Sub Form_Load()
'     lblToolTip.Left = 1 * Screen.TwipsPerPixelX
'     lblToolTip.Top = 0
' End Sub

' --------------------------------------------------------

' Form1's Code:

' Option Explicit

' Private Sub Form_Load()
'     Load frmToolTip
' End Sub

' Private Sub Form_Unload(Cancel As Integer)
'     Unload frmToolTip
' End Sub

' Private Sub Timer1_Timer()
'     Dim TheWindow As Long, _
'     CPos As POINTAPI
'
'     Call GetCursorPos(CPos)
'     TheWindow = WindowFromPoint _
'     (CPos.X, CPos.Y)
'

' --------------------------------------------------------
    ' Don't try to show the ToolTip if the
    ' window is not active.
'   If GetActiveWindow <> Me.hWnd Then Exit Sub
' --------------------------------------------------------

'
'     Select Case TheWindow
'         Case Command1.hWnd
'             frmToolTip.BackColor = &H80000018
'             frmToolTip.lblToolTip.BackColor = &H80000018
'             ShowToolTip TIPONE
'             Timer1.Enabled = False
'         Case Command2.hWnd
'             frmToolTip.BackColor = &H80000018
'             frmToolTip.lblToolTip.BackColor = &H80000018
'             ShowToolTip TIPTWO
'             Timer1.Enabled = False
'         Case Else
'             ShowToolTip ""
'     End Select
' End Sub

' Private Sub Timer2_Timer()
'     Dim TheWindow As Long, CPos As POINTAPI
'     Static OldWindow As Long
'
'     Call GetCursorPos(CPos)
'     TheWindow = WindowFromPoint _
'     (CPos.X, CPos.Y)
'
'     If OldWindow <> TheWindow Then
'         frmToolTip.Hide
'         Timer1.Enabled = True
'     End If
'
'     OldWindow = TheWindow
' End Sub

' --------------------------------------------------------

' Run the project and place the mouse over
' Command1 and Command2.

' The possibilities are endless here. You
' can do things like change the lblToolTip
' color to red to warn the user of important
' things. You can change the Font style and size,
' and on and on
